<template>
  <q-form
    ref="form"
    @submit="onOKClick"
  >
    <q-card-section>
      <q-select
        v-model="timetable"
        filled
        label="Jízdní řád"
        :options="timetableOptions"
        option-value="id"
        option-label="name"
        :rules="[
          val => val || 'Prosím zadejte jízdní řád',
        ]"
        :disable="detail"
        @filter="loadTimetableOptions"
      />

      <div class="row q-mt-md">
        <q-toggle
          v-model="regular"
          label="Spouštět pravidelně"
          unchecked-icon="clear"
          checked-icon="check"
          :disable="detail"
        />
      </div>

      <div
        v-if="regular"
        class="row q-mt-md"
      >
        <div
          v-if="!detail"
          class="col"
        >
          <div>Spustit v:</div>
          <q-time
            v-model="timeCurrent"
            color="secondary"
            format24h
          >
            <div class="row items-center justify-end q-gutter-sm">
              <q-btn
                label="Přidat čas"
                color="primary"
                @click="addTime"
              />
            </div>
          </q-time>
        </div>
        <div class="col justify-evenly column">
          <q-list>
            <q-item
              v-for="t in time"
              :key="t"
              v-ripple
              clickable
            >
              <q-item-section>{{ t }}</q-item-section>

              <q-item-section
                v-if="!detail"
                side
              >
                <q-btn
                  icon="close"
                  flat
                  round
                  @click="() => deleteTime(t)"
                />
              </q-item-section>
            </q-item>
          </q-list>
          <q-select
            v-model="day"
            label="Opakovat dny"
            filled
            multiple
            counter
            use-chips
            :rules="[
              val => val.length || 'Prosím zadejte dny',
            ]"
            :options="dayOptions"
            :disable="detail"
          />
          <q-select
            v-model="month"
            label="Opakovat měsíce"
            filled
            multiple
            counter
            use-chips
            :rules="[
              val => val.length || 'Prosím zadejte měsíce',
            ]"
            :options="monthOptions"
            :disable="detail"
          />
        </div>
      </div>
      <div
        v-if="!regular"
        class="row q-mt-md justify-evenly"
      >
        <q-date
          v-model="onceDate"
          :disable="detail"
        />

        <q-time
          v-model="onceTime"
          color="secondary"
          format24h
          :disable="detail"
        />
      </div>
    </q-card-section>

    <q-separator />

    <buttons
      v-if="showBtns"
      :add-label="addLabel"
      @onCancelClick="$emit('onCancelClick')"
    />
  </q-form>
</template>
<script lang="ts">
import { ref } from '@vue/reactivity'
import _ from 'lodash'
import { useQuasar } from 'quasar'
import { defineComponent } from 'vue'
import { PlannerAdd, PlannerPatch, TimetableModel } from 'web_trains_types'

import Buttons from '@/components/Timetable/Buttons.vue'
import { dateToStr, dayOptions, encodeTime, monthOptions, toDatetime, translateTime } from '@/helper/dateTime'
import { arrayToSelect, SelectOption, selectToArray } from '@/helper/select'
import { plannerService, timetableService } from '@/service'

export default defineComponent({
  name: 'PlannerAddDialog',
  components: {
    Buttons
  },
  props: {
    id: {
      type: Number,
      required: true
    },
    showBtns: {
      type: Boolean,
      reguired: false,
      default: true
    },
    detail: {
      type: Boolean,
      reguired: false,
      default: false
    }
  },
  emits: [
    'onOKClick',
    'onCancelClick'
  ],
  setup (props, { emit }): any {
    const $q = useQuasar()

    const timetable = ref<TimetableModel>()
    const timetableOptions = ref<TimetableModel[]>()

    const regular = ref(true)

    const timeCurrent = ref<string>()
    const time = ref<string[]>([])
    const day = ref<SelectOption[]>([])
    const month = ref<SelectOption[]>([])

    const onceDate = ref<string>()
    const onceTime = ref<string>()

    const addLabel = ref('Uložit')
    const form = ref()

    const loadTimetableOptions = (val: string, update: any) => {
      update(() => {
        if (timetableOptions.value !== undefined) {
          update()
          return
        }

        timetableService.getAll()
          .then((data) => {
            update(() => {
              timetableOptions.value = data
            })
          })
      })
    }

    const addPlanner = (values: PlannerAdd) => {
      return plannerService.add(values)
        .then((data) => {
          $q.notify({
            type: 'positive',
            message: 'Plán byl přidán'
          })
          emit('onOKClick', data)
        })
    }

    const updatePlanner = (values: PlannerPatch, id: number) => {
      return plannerService.patch(id, values)
        .then(() => {
          $q.notify({
            type: 'positive',
            message: 'Plán byl upraven'
          })
          emit('onOKClick')
        })
    }

    const onOKClick = () => {
      $q.loading.show()

      let addUpdatePromise = null

      const values: PlannerAdd = {
        time: null,
        day: null,
        month: null,
        once: null,
        timetableId: timetable.value?.id ?? null
      }

      if (regular.value) {
        values.time = encodeTime(time.value)
        values.day = selectToArray(day.value)
        values.month = selectToArray(month.value)

        if (!values.time.length) {
          $q.notify({
            type: 'warning',
            message: 'Zadejte prosím čas'
          })
          $q.loading.hide()
          return
        }
      } else {
        values.once = toDatetime(onceDate.value, onceTime.value)

        if (values.once === null) {
          $q.notify({
            type: 'negative',
            message: 'Zadejte prosím datum a čas'
          })
          $q.loading.hide()
          return
        }
      }

      if (props.id === 0) {
        addUpdatePromise = addPlanner(values)
      } else {
        addUpdatePromise = updatePlanner(values, props.id)
      }

      addUpdatePromise
        .finally(() => {
          $q.loading.hide()
        })
    }

    const addTime = () => {
      if (timeCurrent.value === undefined || time.value.indexOf(timeCurrent.value) !== -1) {
        return
      }

      time.value?.push(timeCurrent.value)
    }

    const deleteTime = (value: string) => {
      _.remove(time.value, (item) => item === value)
    }

    if (props.id !== 0) {
      $q.loading.show()

      addLabel.value = 'Upravit'

      plannerService.get(props.id)
        .then((planner) => {
          timetable.value = planner.timetable ?? undefined

          if (planner.once) {
            regular.value = false
            onceDate.value = dateToStr(planner.once, 'yyyy/MM/dd')
            onceTime.value = dateToStr(planner.once, 'HH:mm')
          } else {
            regular.value = true
            day.value = arrayToSelect(planner.day, dayOptions)
            month.value = arrayToSelect(planner.month, monthOptions)
            time.value = translateTime(planner.time)
          }
        })
        .finally(() => { $q.loading.hide() })
    }

    return {
      onOKClick,
      loadTimetableOptions,
      timetableOptions,
      timetable,
      regular,
      time,
      timeCurrent,
      addTime,
      deleteTime,
      month,
      monthOptions,
      day,
      dayOptions,
      onceDate,
      onceTime,
      addLabel,
      form,
      submit: () => form.value.submit()
    }
  }
})
</script>
